Merge branch 'ja/doc-synopsis-markup'
[git/gitster.git] / t / test-lib.sh
blobb1a8ee5c002b3572ba7eafee22ac08eeb3daf688
1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see https://www.gnu.org/licenses/ .
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # ensure that TEST_DIRECTORY is an absolute path so that it
23 # is valid even if the current working directory is changed
24 TEST_DIRECTORY=$(pwd)
25 else
26 # The TEST_DIRECTORY will always be the path to the "t"
27 # directory in the git.git checkout. This is overridden by
28 # e.g. t/lib-subtest.sh, but only because its $(pwd) is
29 # different. Those tests still set "$TEST_DIRECTORY" to the
30 # same path.
32 # See use of "$GIT_BUILD_DIR" and "$TEST_DIRECTORY" below for
33 # hard assumptions about "$GIT_BUILD_DIR/t" existing and being
34 # the "$TEST_DIRECTORY", and e.g. "$TEST_DIRECTORY/helper"
35 # needing to exist.
36 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
38 if test -z "$TEST_OUTPUT_DIRECTORY"
39 then
40 # Similarly, override this to store the test-results subdir
41 # elsewhere
42 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
44 GIT_BUILD_DIR="${TEST_DIRECTORY%/t}"
45 if test "$TEST_DIRECTORY" = "$GIT_BUILD_DIR"
46 then
47 echo "PANIC: Running in a $TEST_DIRECTORY that doesn't end in '/t'?" >&2
48 exit 1
50 if test -f "$GIT_BUILD_DIR/GIT-BUILD-DIR"
51 then
52 GIT_BUILD_DIR="$(cat "$GIT_BUILD_DIR/GIT-BUILD-DIR")" || exit 1
53 # On Windows, we must convert Windows paths lest they contain a colon
54 case "$(uname -s)" in
55 *MINGW*)
56 GIT_BUILD_DIR="$(cygpath -au "$GIT_BUILD_DIR")"
58 esac
61 # Prepend a string to a VAR using an arbitrary ":" delimiter, not
62 # adding the delimiter if VAR or VALUE is empty. I.e. a generalized:
64 # VAR=$1${VAR:+${1:+$2}$VAR}
66 # Usage (using ":" as the $2 delimiter):
68 # prepend_var VAR : VALUE
69 prepend_var () {
70 eval "$1=\"$3\${$1:+${3:+$2}\$$1}\""
73 # If [AL]SAN is in effect we want to abort so that we notice
74 # problems. The GIT_SAN_OPTIONS variable can be used to set common
75 # defaults shared between [AL]SAN_OPTIONS.
76 prepend_var GIT_SAN_OPTIONS : abort_on_error=1
77 prepend_var GIT_SAN_OPTIONS : strip_path_prefix="$GIT_BUILD_DIR/"
79 # If we were built with ASAN, it may complain about leaks
80 # of program-lifetime variables. Disable it by default to lower
81 # the noise level. This needs to happen at the start of the script,
82 # before we even do our "did we build git yet" check (since we don't
83 # want that one to complain to stderr).
84 prepend_var ASAN_OPTIONS : $GIT_SAN_OPTIONS
85 prepend_var ASAN_OPTIONS : detect_leaks=0
86 export ASAN_OPTIONS
88 prepend_var LSAN_OPTIONS : $GIT_SAN_OPTIONS
89 prepend_var LSAN_OPTIONS : fast_unwind_on_malloc=0
90 export LSAN_OPTIONS
92 prepend_var UBSAN_OPTIONS : $GIT_SAN_OPTIONS
93 export UBSAN_OPTIONS
95 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
96 then
97 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
98 exit 1
100 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
101 export PERL_PATH SHELL_PATH
103 # In t0000, we need to override test directories of nested testcases. In case
104 # the developer has TEST_OUTPUT_DIRECTORY part of his build options, then we'd
105 # reset this value to instead contain what the developer has specified. We thus
106 # have this knob to allow overriding the directory.
107 if test -n "${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
108 then
109 TEST_OUTPUT_DIRECTORY="${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
112 # Disallow the use of abbreviated options in the test suite by default
113 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
114 then
115 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
116 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
119 # Explicitly set the default branch name for testing, to avoid the
120 # transitory "git init" warning under --verbose.
121 : ${GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME:=master}
122 export GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME
124 ################################################################
125 # It appears that people try to run tests without building...
126 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
127 if test $? != 1
128 then
129 if test -n "$GIT_TEST_INSTALLED"
130 then
131 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
132 else
133 echo >&2 'error: you do not seem to have built git yet.'
135 exit 1
138 store_arg_to=
139 opt_required_arg=
140 # $1: option string
141 # $2: name of the var where the arg will be stored
142 mark_option_requires_arg () {
143 if test -n "$opt_required_arg"
144 then
145 echo "error: options that require args cannot be bundled" \
146 "together: '$opt_required_arg' and '$1'" >&2
147 exit 1
149 opt_required_arg=$1
150 store_arg_to=$2
153 # These functions can be overridden e.g. to output JUnit XML
154 start_test_output () { :; }
155 start_test_case_output () { :; }
156 finalize_test_case_output () { :; }
157 finalize_test_output () { :; }
159 parse_option () {
160 local opt="$1"
162 case "$opt" in
163 -d|--d|--de|--deb|--debu|--debug)
164 debug=t ;;
165 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
166 immediate=t ;;
167 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
168 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
170 mark_option_requires_arg "$opt" run_list
172 --run=*)
173 run_list=${opt#--*=} ;;
174 -h|--h|--he|--hel|--help)
175 help=t ;;
176 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
177 verbose=t ;;
178 --verbose-only=*)
179 verbose_only=${opt#--*=}
181 -q|--q|--qu|--qui|--quie|--quiet)
182 # Ignore --quiet under a TAP::Harness. Saying how many tests
183 # passed without the ok/not ok details is always an error.
184 test -z "$HARNESS_ACTIVE" && quiet=t ;;
185 --with-dashes)
186 with_dashes=t ;;
187 --no-bin-wrappers)
188 no_bin_wrappers=t ;;
189 --no-color)
190 color= ;;
191 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
192 valgrind=memcheck
193 tee=t
195 --valgrind=*)
196 valgrind=${opt#--*=}
197 tee=t
199 --valgrind-only=*)
200 valgrind_only=${opt#--*=}
201 tee=t
203 --tee)
204 tee=t ;;
205 --root=*)
206 root=${opt#--*=} ;;
207 --chain-lint)
208 GIT_TEST_CHAIN_LINT=1 ;;
209 --no-chain-lint)
210 GIT_TEST_CHAIN_LINT=0 ;;
212 trace=t ;;
213 -V|--verbose-log)
214 verbose_log=t
215 tee=t
217 --write-junit-xml)
218 . "$TEST_DIRECTORY/test-lib-junit.sh"
220 --github-workflow-markup)
221 . "$TEST_DIRECTORY/test-lib-github-workflow-markup.sh"
223 --stress)
224 stress=t ;;
225 --stress=*)
226 echo "error: --stress does not accept an argument: '$opt'" >&2
227 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
228 exit 1
230 --stress-jobs=*)
231 stress=t;
232 stress_jobs=${opt#--*=}
233 case "$stress_jobs" in
234 *[!0-9]*|0*|"")
235 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
236 exit 1
238 *) # Good.
240 esac
242 --stress-limit=*)
243 stress=t;
244 stress_limit=${opt#--*=}
245 case "$stress_limit" in
246 *[!0-9]*|0*|"")
247 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
248 exit 1
250 *) # Good.
252 esac
254 --invert-exit-code)
255 invert_exit_code=t
258 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
259 esac
262 # Parse options while taking care to leave $@ intact, so we will still
263 # have all the original command line options when executing the test
264 # script again for '--tee' and '--verbose-log' later.
265 for opt
267 if test -n "$store_arg_to"
268 then
269 eval $store_arg_to=\$opt
270 store_arg_to=
271 opt_required_arg=
272 continue
275 case "$opt" in
276 --*|-?)
277 parse_option "$opt" ;;
278 -?*)
279 # bundled short options must be fed separately to parse_option
280 opt=${opt#-}
281 while test -n "$opt"
283 extra=${opt#?}
284 this=${opt%$extra}
285 opt=$extra
286 parse_option "-$this"
287 done
290 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
291 esac
292 done
293 if test -n "$store_arg_to"
294 then
295 echo "error: $opt_required_arg requires an argument" >&2
296 exit 1
299 if test -n "$valgrind_only"
300 then
301 test -z "$valgrind" && valgrind=memcheck
302 test -z "$verbose" && verbose_only="$valgrind_only"
303 elif test -n "$valgrind"
304 then
305 test -z "$verbose_log" && verbose=t
308 if test -n "$stress"
309 then
310 verbose=t
311 trace=t
312 immediate=t
315 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
316 TEST_NAME="$(basename "$0" .sh)"
317 TEST_NUMBER="${TEST_NAME%%-*}"
318 TEST_NUMBER="${TEST_NUMBER#t}"
319 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
320 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
321 TEST_RESULTS_SAN_FILE_PFX=trace
322 TEST_RESULTS_SAN_DIR_SFX=leak
323 TEST_RESULTS_SAN_FILE=
324 TEST_RESULTS_SAN_DIR="$TEST_RESULTS_DIR/$TEST_NAME.$TEST_RESULTS_SAN_DIR_SFX"
325 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
326 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
327 case "$TRASH_DIRECTORY" in
328 /*) ;; # absolute path is good
329 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
330 esac
332 # Utility functions using $TEST_RESULTS_* variables
333 nr_san_dir_leaks_ () {
334 # stderr piped to /dev/null because the directory may have
335 # been "rmdir"'d already.
336 find "$TEST_RESULTS_SAN_DIR" \
337 -type f \
338 -name "$TEST_RESULTS_SAN_FILE_PFX.*" 2>/dev/null |
339 xargs grep -lv "Unable to get registers from thread" |
340 wc -l
343 # If --stress was passed, run this test repeatedly in several parallel loops.
344 if test "$GIT_TEST_STRESS_STARTED" = "done"
345 then
346 : # Don't stress test again.
347 elif test -n "$stress"
348 then
349 if test -n "$stress_jobs"
350 then
351 job_count=$stress_jobs
352 elif test -n "$GIT_TEST_STRESS_LOAD"
353 then
354 job_count="$GIT_TEST_STRESS_LOAD"
355 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
356 test -n "$job_count"
357 then
358 job_count=$((2 * $job_count))
359 else
360 job_count=8
363 mkdir -p "$TEST_RESULTS_DIR"
364 stressfail="$TEST_RESULTS_BASE.stress-failed"
365 rm -f "$stressfail"
367 stress_exit=0
368 trap '
369 kill $job_pids 2>/dev/null
370 wait
371 stress_exit=1
372 ' TERM INT HUP
374 job_pids=
375 job_nr=0
376 while test $job_nr -lt "$job_count"
379 GIT_TEST_STRESS_STARTED=done
380 GIT_TEST_STRESS_JOB_NR=$job_nr
381 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
383 trap '
384 kill $test_pid 2>/dev/null
385 wait
386 exit 1
387 ' TERM INT
389 cnt=1
390 while ! test -e "$stressfail" &&
391 { test -z "$stress_limit" ||
392 test $cnt -le $stress_limit ; }
394 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
395 test_pid=$!
397 if wait $test_pid
398 then
399 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
400 else
401 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
402 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
404 cnt=$(($cnt + 1))
405 done
407 job_pids="$job_pids $!"
408 job_nr=$(($job_nr + 1))
409 done
411 wait
413 if test -f "$stressfail"
414 then
415 stress_exit=1
416 echo "Log(s) of failed test run(s):"
417 for failed_job_nr in $(sort -n "$stressfail")
419 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
420 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
421 done
422 rm -rf "$TRASH_DIRECTORY.stress-failed"
423 # Move the last one.
424 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
427 exit $stress_exit
430 # if --tee was passed, write the output not only to the terminal, but
431 # additionally to the file test-results/$BASENAME.out, too.
432 if test "$GIT_TEST_TEE_STARTED" = "done"
433 then
434 : # do not redirect again
435 elif test -n "$tee"
436 then
437 mkdir -p "$TEST_RESULTS_DIR"
439 # Make this filename available to the sub-process in case it is using
440 # --verbose-log.
441 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
442 export GIT_TEST_TEE_OUTPUT_FILE
444 # Truncate before calling "tee -a" to get rid of the results
445 # from any previous runs.
446 >"$GIT_TEST_TEE_OUTPUT_FILE"
448 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
449 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
450 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
451 exit
454 if test -n "$trace" && test -n "$test_untraceable"
455 then
456 # '-x' tracing requested, but this test script can't be reliably
457 # traced, unless it is run with a Bash version supporting
458 # BASH_XTRACEFD (introduced in Bash v4.1).
460 # Perform this version check _after_ the test script was
461 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
462 # '--verbose-log', so the right shell is checked and the
463 # warning is issued only once.
464 if test -n "$BASH_VERSION" && eval '
465 test ${BASH_VERSINFO[0]} -gt 4 || {
466 test ${BASH_VERSINFO[0]} -eq 4 &&
467 test ${BASH_VERSINFO[1]} -ge 1
470 then
471 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
472 else
473 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
474 trace=
477 if test -n "$trace" && test -z "$verbose_log"
478 then
479 verbose=t
482 # Since bash 5.0, checkwinsize is enabled by default which does
483 # update the COLUMNS variable every time a non-builtin command
484 # completes, even for non-interactive shells.
485 # Disable that since we are aiming for repeatability.
486 test -n "$BASH_VERSION" && shopt -u checkwinsize 2>/dev/null
488 # For repeatability, reset the environment to known value.
489 # TERM is sanitized below, after saving color control sequences.
490 LANG=C
491 LC_ALL=C
492 PAGER=cat
493 TZ=UTC
494 COLUMNS=80
495 export LANG LC_ALL PAGER TZ COLUMNS
496 EDITOR=:
498 # A call to "unset" with no arguments causes at least Solaris 10
499 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
500 # deriving from the command substitution clustered with the other
501 # ones.
502 unset VISUAL EMAIL LANGUAGE $("$PERL_PATH" -e '
503 my @env = keys %ENV;
504 my $ok = join("|", qw(
505 TRACE
506 DEBUG
507 TEST
508 .*_TEST
509 PROVE
510 VALGRIND
511 UNZIP
512 PERF_
513 CURL_VERBOSE
514 TRACE_CURL
516 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
517 print join("\n", @vars);
519 unset XDG_CACHE_HOME
520 unset XDG_CONFIG_HOME
521 unset GITPERLLIB
522 unset GIT_TRACE2_PARENT_NAME
523 unset GIT_TRACE2_PARENT_SID
524 TEST_AUTHOR_LOCALNAME=author
525 TEST_AUTHOR_DOMAIN=example.com
526 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
527 GIT_AUTHOR_NAME='A U Thor'
528 GIT_AUTHOR_DATE='1112354055 +0200'
529 TEST_COMMITTER_LOCALNAME=committer
530 TEST_COMMITTER_DOMAIN=example.com
531 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
532 GIT_COMMITTER_NAME='C O Mitter'
533 GIT_COMMITTER_DATE='1112354055 +0200'
534 GIT_MERGE_VERBOSITY=5
535 GIT_MERGE_AUTOEDIT=no
536 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
537 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
538 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
539 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
540 export EDITOR
542 GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
543 export GIT_DEFAULT_HASH
544 GIT_DEFAULT_REF_FORMAT="${GIT_TEST_DEFAULT_REF_FORMAT:-files}"
545 export GIT_DEFAULT_REF_FORMAT
546 GIT_TEST_MERGE_ALGORITHM="${GIT_TEST_MERGE_ALGORITHM:-ort}"
547 export GIT_TEST_MERGE_ALGORITHM
549 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
550 GIT_TRACE_BARE=1
551 export GIT_TRACE_BARE
553 # Some tests scan the GIT_TRACE2_EVENT feed for events, but the
554 # default depth is 2, which frequently causes issues when the
555 # events are wrapped in new regions. Set it to a sufficiently
556 # large depth to avoid custom changes in the test suite.
557 GIT_TRACE2_EVENT_NESTING=100
558 export GIT_TRACE2_EVENT_NESTING
560 # Use specific version of the index file format
561 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
562 then
563 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
564 export GIT_INDEX_VERSION
567 if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
568 then
569 GIT_PERL_FATAL_WARNINGS=1
570 export GIT_PERL_FATAL_WARNINGS
573 case $GIT_TEST_FSYNC in
575 GIT_TEST_FSYNC=0
576 export GIT_TEST_FSYNC
578 esac
580 # Add libc MALLOC and MALLOC_PERTURB test only if we are not executing
581 # the test with valgrind and have not compiled with conflict SANITIZE
582 # options.
583 if test -n "$valgrind" ||
584 test -n "$SANITIZE_ADDRESS" ||
585 test -n "$SANITIZE_LEAK" ||
586 test -n "$TEST_NO_MALLOC_CHECK"
587 then
588 setup_malloc_check () {
589 : nothing
591 teardown_malloc_check () {
592 : nothing
594 else
595 _USE_GLIBC_TUNABLES=
596 if _GLIBC_VERSION=$(getconf GNU_LIBC_VERSION 2>/dev/null) &&
597 _GLIBC_VERSION=${_GLIBC_VERSION#"glibc "} &&
598 expr 2.34 \<= "$_GLIBC_VERSION" >/dev/null
599 then
600 _USE_GLIBC_TUNABLES=YesPlease
602 setup_malloc_check () {
603 local g
604 local t
605 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
606 export MALLOC_CHECK_ MALLOC_PERTURB_
607 if test -n "$_USE_GLIBC_TUNABLES"
608 then
610 LD_PRELOAD="libc_malloc_debug.so.0"
611 for t in \
612 glibc.malloc.check=1 \
613 glibc.malloc.perturb=165
615 g="${g#:}:$t"
616 done
617 GLIBC_TUNABLES=$g
618 export LD_PRELOAD GLIBC_TUNABLES
621 teardown_malloc_check () {
622 unset MALLOC_CHECK_ MALLOC_PERTURB_
623 unset LD_PRELOAD GLIBC_TUNABLES
627 # Protect ourselves from common misconfiguration to export
628 # CDPATH into the environment
629 unset CDPATH
631 unset GREP_OPTIONS
632 unset UNZIP
634 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
635 1|2|true)
636 GIT_TRACE=4
638 esac
640 # Line feed
641 LF='
644 # Single quote
645 SQ=\'
647 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
648 # when case-folding filenames
649 u200c=$(printf '\342\200\214')
651 export _x05 _x35 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
653 test "x$TERM" != "xdumb" && (
654 test -t 1 &&
655 tput bold >/dev/null 2>&1 &&
656 tput setaf 1 >/dev/null 2>&1 &&
657 tput sgr0 >/dev/null 2>&1
658 ) &&
659 color=t
661 if test -n "$color"
662 then
663 # Save the color control sequences now rather than run tput
664 # each time say_color() is called. This is done for two
665 # reasons:
666 # * TERM will be changed to dumb
667 # * HOME will be changed to a temporary directory and tput
668 # might need to read ~/.terminfo from the original HOME
669 # directory to get the control sequences
670 # Note: This approach assumes the control sequences don't end
671 # in a newline for any terminal of interest (command
672 # substitutions strip trailing newlines). Given that most
673 # (all?) terminals in common use are related to ECMA-48, this
674 # shouldn't be a problem.
675 say_color_error=$(tput bold; tput setaf 1) # bold red
676 say_color_skip=$(tput setaf 4) # blue
677 say_color_warn=$(tput setaf 3) # brown/yellow
678 say_color_pass=$(tput setaf 2) # green
679 say_color_info=$(tput setaf 6) # cyan
680 say_color_reset=$(tput sgr0)
681 say_color_="" # no formatting for normal text
682 say_color () {
683 test -z "$1" && test -n "$quiet" && return
684 eval "say_color_color=\$say_color_$1"
685 shift
686 printf "%s\\n" "$say_color_color$*$say_color_reset"
688 else
689 say_color() {
690 test -z "$1" && test -n "$quiet" && return
691 shift
692 printf "%s\n" "$*"
696 USER_TERM="$TERM"
697 TERM=dumb
698 export TERM USER_TERM
700 # What is written by tests to stdout and stderr is sent to different places
701 # depending on the test mode (e.g. /dev/null in non-verbose mode, piped to tee
702 # with --tee option, etc.). We save the original stdin to FD #6 and stdout and
703 # stderr to #5 and #7, so that the test framework can use them (e.g. for
704 # printing errors within the test framework) independently of the test mode.
705 exec 5>&1
706 exec 6<&0
707 exec 7>&2
709 _error_exit () {
710 finalize_test_output
711 GIT_EXIT_OK=t
712 exit 1
715 error () {
716 say_color error "error: $*"
717 _error_exit
720 BUG () {
721 error >&7 "bug in the test script: $*"
724 BAIL_OUT () {
725 test $# -ne 1 && BUG "1 param"
727 # Do not change "Bail out! " string. It's part of TAP syntax:
728 # https://testanything.org/tap-specification.html
729 local bail_out="Bail out! "
730 local message="$1"
732 say_color >&5 error $bail_out "$message"
733 _error_exit
736 say () {
737 say_color info "$*"
740 if test -n "$HARNESS_ACTIVE"
741 then
742 if test "$verbose" = t || test -n "$verbose_only"
743 then
744 BAIL_OUT 'verbose mode forbidden under TAP harness; try --verbose-log'
748 test "${test_description}" != "" ||
749 error "Test script did not set test_description."
751 if test "$help" = "t"
752 then
753 printf '%s\n' "$test_description"
754 exit 0
757 if test "$verbose_log" = "t"
758 then
759 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
760 elif test "$verbose" = "t"
761 then
762 exec 4>&2 3>&1
763 else
764 exec 4>/dev/null 3>/dev/null
767 # Send any "-x" output directly to stderr to avoid polluting tests
768 # which capture stderr. We can do this unconditionally since it
769 # has no effect if tracing isn't turned on.
771 # Note that this sets up the trace fd as soon as we assign the variable, so it
772 # must come after the creation of descriptor 4 above. Likewise, we must never
773 # unset this, as it has the side effect of closing descriptor 4, which we
774 # use to show verbose tests to the user.
776 # Note also that we don't need or want to export it. The tracing is local to
777 # this shell, and we would not want to influence any shells we exec.
778 BASH_XTRACEFD=4
780 test_failure=0
781 test_count=0
782 test_fixed=0
783 test_broken=0
784 test_success=0
786 test_missing_prereq=
788 test_external_has_tap=0
790 die () {
791 code=$?
792 # This is responsible for running the atexit commands even when a
793 # test script run with '--immediate' fails, or when the user hits
794 # ctrl-C, i.e. when 'test_done' is not invoked at all.
795 test_atexit_handler || code=$?
796 if test -n "$GIT_EXIT_OK"
797 then
798 exit $code
799 else
800 echo >&5 "FATAL: Unexpected exit with code $code"
801 exit 1
805 GIT_EXIT_OK=
806 trap 'die' EXIT
807 # Disable '-x' tracing, because with some shells, notably dash, it
808 # prevents running the cleanup commands when a test script run with
809 # '--verbose-log -x' is interrupted.
810 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
812 # The user-facing functions are loaded from a separate file so that
813 # test_perf subshells can have them too
814 . "$TEST_DIRECTORY/test-lib-functions.sh"
816 # You are not expected to call test_ok_ and test_failure_ directly, use
817 # the test_expect_* functions instead.
819 test_ok_ () {
820 test_success=$(($test_success + 1))
821 say_color "" "ok $test_count - $@"
822 finalize_test_case_output ok "$@"
825 _invert_exit_code_failure_end_blurb () {
826 say_color warn "# faked up failures as TODO & now exiting with 0 due to --invert-exit-code"
829 test_failure_ () {
830 failure_label=$1
831 test_failure=$(($test_failure + 1))
832 local pfx=""
833 if test -n "$invert_exit_code" # && test -n "$HARNESS_ACTIVE"
834 then
835 pfx="# TODO induced breakage (--invert-exit-code):"
837 say_color error "not ok $test_count - ${pfx:+$pfx }$1"
838 shift
839 printf '%s\n' "$*" | sed -e 's/^/# /'
840 if test -n "$immediate"
841 then
842 say_color error "1..$test_count"
843 if test -n "$invert_exit_code"
844 then
845 finalize_test_output
846 _invert_exit_code_failure_end_blurb
847 GIT_EXIT_OK=t
848 exit 0
850 check_test_results_san_file_ "$test_failure"
851 _error_exit
853 finalize_test_case_output failure "$failure_label" "$@"
856 test_known_broken_ok_ () {
857 test_fixed=$(($test_fixed+1))
858 say_color error "ok $test_count - $1 # TODO known breakage vanished"
859 finalize_test_case_output fixed "$1"
862 test_known_broken_failure_ () {
863 test_broken=$(($test_broken+1))
864 say_color warn "not ok $test_count - $1 # TODO known breakage"
865 finalize_test_case_output broken "$1"
868 test_debug () {
869 test "$debug" = "" || eval "$1"
872 match_pattern_list () {
873 arg="$1"
874 shift
875 test -z "$*" && return 1
876 # We need to use "$*" to get field-splitting, but we want to
877 # disable globbing, since we are matching against an arbitrary
878 # $arg, not what's in the filesystem. Using "set -f" accomplishes
879 # that, but we must do it in a subshell to avoid impacting the
880 # rest of the script. The exit value of the subshell becomes
881 # the function's return value.
883 set -f
884 for pattern_ in $*
886 case "$arg" in
887 $pattern_)
888 exit 0
890 esac
891 done
892 exit 1
896 match_test_selector_list () {
897 operation="$1"
898 shift
899 title="$1"
900 shift
901 arg="$1"
902 shift
903 test -z "$1" && return 0
905 # Commas are accepted as separators.
906 OLDIFS=$IFS
907 IFS=','
908 set -- $1
909 IFS=$OLDIFS
911 # If the first selector is negative we include by default.
912 include=
913 case "$1" in
914 !*) include=t ;;
915 esac
917 for selector
919 orig_selector=$selector
921 positive=t
922 case "$selector" in
924 positive=
925 selector=${selector##?}
927 esac
929 test -z "$selector" && continue
931 case "$selector" in
932 *-*)
933 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
934 then
935 echo "error: $operation: invalid non-numeric in range" \
936 "start: '$orig_selector'" >&2
937 exit 1
939 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
940 then
941 echo "error: $operation: invalid non-numeric in range" \
942 "end: '$orig_selector'" >&2
943 exit 1
947 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
948 then
949 case "$title" in *${selector}*)
950 include=$positive
952 esac
953 continue
955 esac
957 # Short cut for "obvious" cases
958 test -z "$include" && test -z "$positive" && continue
959 test -n "$include" && test -n "$positive" && continue
961 case "$selector" in
963 if test $arg -le ${selector#-}
964 then
965 include=$positive
969 if test $arg -ge ${selector%-}
970 then
971 include=$positive
974 *-*)
975 if test ${selector%%-*} -le $arg \
976 && test $arg -le ${selector#*-}
977 then
978 include=$positive
982 if test $arg -eq $selector
983 then
984 include=$positive
987 esac
988 done
990 test -n "$include"
993 maybe_teardown_verbose () {
994 test -z "$verbose_only" && return
995 exec 4>/dev/null 3>/dev/null
996 verbose=
999 last_verbose=t
1000 maybe_setup_verbose () {
1001 test -z "$verbose_only" && return
1002 if match_pattern_list $test_count "$verbose_only"
1003 then
1004 exec 4>&2 3>&1
1005 # Emit a delimiting blank line when going from
1006 # non-verbose to verbose. Within verbose mode the
1007 # delimiter is printed by test_expect_*. The choice
1008 # of the initial $last_verbose is such that before
1009 # test 1, we do not print it.
1010 test -z "$last_verbose" && echo >&3 ""
1011 verbose=t
1012 else
1013 exec 4>/dev/null 3>/dev/null
1014 verbose=
1016 last_verbose=$verbose
1019 maybe_teardown_valgrind () {
1020 test -z "$GIT_VALGRIND" && return
1021 GIT_VALGRIND_ENABLED=
1024 maybe_setup_valgrind () {
1025 test -z "$GIT_VALGRIND" && return
1026 if test -z "$valgrind_only"
1027 then
1028 GIT_VALGRIND_ENABLED=t
1029 return
1031 GIT_VALGRIND_ENABLED=
1032 if match_pattern_list $test_count "$valgrind_only"
1033 then
1034 GIT_VALGRIND_ENABLED=t
1038 trace_level_=0
1039 want_trace () {
1040 test "$trace" = t && {
1041 test "$verbose" = t || test "$verbose_log" = t
1045 # This is a separate function because some tests use
1046 # "return" to end a test_expect_success block early
1047 # (and we want to make sure we run any cleanup like
1048 # "set +x").
1049 test_eval_inner_ () {
1050 eval "$*"
1053 test_eval_ () {
1054 # If "-x" tracing is in effect, then we want to avoid polluting stderr
1055 # with non-test commands. But once in "set -x" mode, we cannot prevent
1056 # the shell from printing the "set +x" to turn it off (nor the saving
1057 # of $? before that). But we can make sure that the output goes to
1058 # /dev/null.
1060 # There are a few subtleties here:
1062 # - we have to redirect descriptor 4 in addition to 2, to cover
1063 # BASH_XTRACEFD
1065 # - the actual eval has to come before the redirection block (since
1066 # it needs to see descriptor 4 to set up its stderr)
1068 # - likewise, any error message we print must be outside the block to
1069 # access descriptor 4
1071 # - checking $? has to come immediately after the eval, but it must
1072 # be _inside_ the block to avoid polluting the "set -x" output
1075 # Do not add anything extra (including LF) after '$*'
1076 test_eval_inner_ </dev/null >&3 2>&4 "
1077 want_trace && trace_level_=$(($trace_level_+1)) && set -x
1080 test_eval_ret_=$?
1081 if want_trace
1082 then
1083 test 1 = $trace_level_ && set +x
1084 trace_level_=$(($trace_level_-1))
1086 } 2>/dev/null 4>&2
1088 if test "$test_eval_ret_" != 0 && want_trace
1089 then
1090 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
1092 return $test_eval_ret_
1095 fail_117 () {
1096 return 117
1099 test_run_ () {
1100 test_cleanup=:
1101 expecting_failure=$2
1103 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
1104 # 117 is magic because it is unlikely to match the exit
1105 # code of other programs
1106 test_eval_inner_ "fail_117 && $1" </dev/null >&3 2>&4
1107 if test $? != 117
1108 then
1109 BUG "broken &&-chain: $1"
1113 setup_malloc_check
1114 test_eval_ "$1"
1115 eval_ret=$?
1116 teardown_malloc_check
1118 if test -z "$immediate" || test $eval_ret = 0 ||
1119 test -n "$expecting_failure" && test "$test_cleanup" != ":"
1120 then
1121 setup_malloc_check
1122 test_eval_ "$test_cleanup"
1123 teardown_malloc_check
1125 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
1126 then
1127 echo ""
1129 return "$eval_ret"
1132 test_start_ () {
1133 test_count=$(($test_count+1))
1134 maybe_setup_verbose
1135 maybe_setup_valgrind
1136 start_test_case_output "$@"
1139 test_finish_ () {
1140 echo >&3 ""
1141 maybe_teardown_valgrind
1142 maybe_teardown_verbose
1143 if test -n "$GIT_TEST_TEE_OFFSET"
1144 then
1145 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1146 "$GIT_TEST_TEE_OUTPUT_FILE")
1150 test_skip () {
1151 to_skip=
1152 skipped_reason=
1153 if match_pattern_list $this_test.$test_count "$GIT_SKIP_TESTS"
1154 then
1155 to_skip=t
1156 skipped_reason="GIT_SKIP_TESTS"
1158 if test -z "$to_skip" && test -n "$run_list" &&
1159 ! match_test_selector_list '--run' "$1" $test_count "$run_list"
1160 then
1161 to_skip=t
1162 skipped_reason="--run"
1164 if test -z "$to_skip" && test -n "$test_prereq" &&
1165 ! test_have_prereq "$test_prereq"
1166 then
1167 to_skip=t
1169 of_prereq=
1170 if test "$missing_prereq" != "$test_prereq"
1171 then
1172 of_prereq=" of $test_prereq"
1174 skipped_reason="missing $missing_prereq${of_prereq}"
1176 # Keep a list of all the missing prereq for result aggregation
1177 if test -z "$missing_prereq"
1178 then
1179 test_missing_prereq=$missing_prereq
1180 else
1181 test_missing_prereq="$test_missing_prereq,$missing_prereq"
1185 case "$to_skip" in
1188 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1189 : true
1190 finalize_test_case_output skip "$@"
1193 false
1195 esac
1198 # stub; perf-lib overrides it
1199 test_at_end_hook_ () {
1203 test_atexit_cleanup=:
1204 test_atexit_handler () {
1205 # In a succeeding test script 'test_atexit_handler' is invoked
1206 # twice: first from 'test_done', then from 'die' in the trap on
1207 # EXIT.
1208 # This condition and resetting 'test_atexit_cleanup' below makes
1209 # sure that the registered cleanup commands are run only once.
1210 test : != "$test_atexit_cleanup" || return 0
1212 setup_malloc_check
1213 test_eval_ "$test_atexit_cleanup"
1214 test_atexit_cleanup=:
1215 teardown_malloc_check
1218 check_test_results_san_file_empty_ () {
1219 test -z "$TEST_RESULTS_SAN_FILE" ||
1220 test "$(nr_san_dir_leaks_)" = 0
1223 check_test_results_san_file_ () {
1224 if check_test_results_san_file_empty_
1225 then
1226 return
1227 fi &&
1228 say_color error "$(cat "$TEST_RESULTS_SAN_FILE".*)" &&
1230 if test -n "$passes_sanitize_leak" && test "$test_failure" = 0
1231 then
1232 say "As TEST_PASSES_SANITIZE_LEAK=true and our logs show we're leaking, exit non-zero!" &&
1233 invert_exit_code=t
1234 elif test -n "$passes_sanitize_leak"
1235 then
1236 say "As TEST_PASSES_SANITIZE_LEAK=true and our logs show we're leaking, and we're failing for other reasons too..." &&
1237 invert_exit_code=
1238 elif test -n "$sanitize_leak_check" && test "$test_failure" = 0
1239 then
1240 say "As TEST_PASSES_SANITIZE_LEAK=true isn't set the above leak is 'ok' with GIT_TEST_PASSING_SANITIZE_LEAK=check" &&
1241 invert_exit_code=
1242 elif test -n "$sanitize_leak_check"
1243 then
1244 say "As TEST_PASSES_SANITIZE_LEAK=true isn't set the above leak is 'ok' with GIT_TEST_PASSING_SANITIZE_LEAK=check" &&
1245 invert_exit_code=t
1246 elif test "$test_failure" = 0
1247 then
1248 say "Our logs revealed a memory leak, exit non-zero!" &&
1249 invert_exit_code=t
1250 else
1251 say "Our logs revealed a memory leak..."
1255 test_done () {
1256 # Run the atexit commands _before_ the trash directory is
1257 # removed, so the commands can access pidfiles and socket files.
1258 test_atexit_handler
1260 finalize_test_output
1262 if test -z "$HARNESS_ACTIVE"
1263 then
1264 mkdir -p "$TEST_RESULTS_DIR"
1266 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1267 total $test_count
1268 success $test_success
1269 fixed $test_fixed
1270 broken $test_broken
1271 failed $test_failure
1272 missing_prereq $test_missing_prereq
1277 if test -z "$passes_sanitize_leak" && test_bool_env TEST_PASSES_SANITIZE_LEAK false
1278 then
1279 BAIL_OUT "Please, set TEST_PASSES_SANITIZE_LEAK before sourcing test-lib.sh"
1282 if test "$test_fixed" != 0
1283 then
1284 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1286 if test "$test_broken" != 0
1287 then
1288 say_color warn "# still have $test_broken known breakage(s)"
1290 if test "$test_broken" != 0 || test "$test_fixed" != 0
1291 then
1292 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1293 msg="remaining $test_remaining test(s)"
1294 else
1295 test_remaining=$test_count
1296 msg="$test_count test(s)"
1298 case "$test_failure" in
1300 if test $test_remaining -gt 0
1301 then
1302 say_color pass "# passed all $msg"
1305 # Maybe print SKIP message
1306 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1307 case "$test_count" in
1309 say "1..$test_count${skip_all:+ $skip_all}"
1312 test -z "$skip_all" ||
1313 say_color warn "$skip_all"
1314 say "1..$test_count"
1316 esac
1318 if test -n "$stress" && test -n "$invert_exit_code"
1319 then
1320 # We're about to move our "$TRASH_DIRECTORY"
1321 # to "$TRASH_DIRECTORY.stress-failed" if
1322 # --stress is combined with
1323 # --invert-exit-code.
1324 say "with --stress and --invert-exit-code we're not removing '$TRASH_DIRECTORY'"
1325 elif test -z "$debug" && test -n "$remove_trash"
1326 then
1327 test -d "$TRASH_DIRECTORY" ||
1328 error "Tests passed but trash directory already removed before test cleanup; aborting"
1330 cd "$TRASH_DIRECTORY/.." &&
1331 rm -fr "$TRASH_DIRECTORY" || {
1332 # try again in a bit
1333 sleep 5;
1334 rm -fr "$TRASH_DIRECTORY"
1335 } ||
1336 error "Tests passed but test cleanup failed; aborting"
1339 check_test_results_san_file_ "$test_failure"
1341 if test -z "$skip_all" && test -n "$invert_exit_code"
1342 then
1343 say_color warn "# faking up non-zero exit with --invert-exit-code"
1344 GIT_EXIT_OK=t
1345 exit 1
1348 test_at_end_hook_
1350 GIT_EXIT_OK=t
1351 exit 0 ;;
1354 say_color error "# failed $test_failure among $msg"
1355 say "1..$test_count"
1357 check_test_results_san_file_ "$test_failure"
1359 if test -n "$invert_exit_code"
1360 then
1361 _invert_exit_code_failure_end_blurb
1362 GIT_EXIT_OK=t
1363 exit 0
1366 GIT_EXIT_OK=t
1367 exit 1 ;;
1369 esac
1372 if test -n "$valgrind"
1373 then
1374 make_symlink () {
1375 test -h "$2" &&
1376 test "$1" = "$(readlink "$2")" || {
1377 # be super paranoid
1378 if mkdir "$2".lock
1379 then
1380 rm -f "$2" &&
1381 ln -s "$1" "$2" &&
1382 rm -r "$2".lock
1383 else
1384 while test -d "$2".lock
1386 say "Waiting for lock on $2."
1387 sleep 1
1388 done
1393 make_valgrind_symlink () {
1394 # handle only executables, unless they are shell libraries that
1395 # need to be in the exec-path.
1396 test -x "$1" ||
1397 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1398 return;
1400 base=$(basename "$1")
1401 case "$base" in
1402 test-*)
1403 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1406 symlink_target="$GIT_BUILD_DIR/$base"
1408 esac
1409 # do not override scripts
1410 if test -x "$symlink_target" &&
1411 test ! -d "$symlink_target" &&
1412 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1413 then
1414 symlink_target=../valgrind.sh
1416 case "$base" in
1417 *.sh|*.perl)
1418 symlink_target=../unprocessed-script
1419 esac
1420 # create the link, or replace it if it is out of date
1421 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1424 # override all git executables in TEST_DIRECTORY/..
1425 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1426 mkdir -p "$GIT_VALGRIND"/bin
1427 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1429 make_valgrind_symlink $file
1430 done
1431 # special-case the mergetools loadables
1432 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1433 OLDIFS=$IFS
1434 IFS=:
1435 for path in $PATH
1437 ls "$path"/git-* 2> /dev/null |
1438 while read file
1440 make_valgrind_symlink "$file"
1441 done
1442 done
1443 IFS=$OLDIFS
1444 PATH=$GIT_VALGRIND/bin:$PATH
1445 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1446 export GIT_VALGRIND
1447 GIT_VALGRIND_MODE="$valgrind"
1448 export GIT_VALGRIND_MODE
1449 GIT_VALGRIND_ENABLED=t
1450 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1451 export GIT_VALGRIND_ENABLED
1452 elif test -n "$GIT_TEST_INSTALLED"
1453 then
1454 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1455 error "Cannot run git from $GIT_TEST_INSTALLED."
1456 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1457 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1458 else # normal case, use ../bin-wrappers only unless $with_dashes:
1459 if test -n "$no_bin_wrappers"
1460 then
1461 with_dashes=t
1462 else
1463 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1464 if ! test -x "$git_bin_dir/git"
1465 then
1466 if test -z "$with_dashes"
1467 then
1468 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1470 with_dashes=t
1472 PATH="$git_bin_dir:$PATH"
1474 GIT_EXEC_PATH=$GIT_BUILD_DIR
1475 if test -n "$with_dashes"
1476 then
1477 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1480 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1481 GIT_CONFIG_NOSYSTEM=1
1482 GIT_ATTR_NOSYSTEM=1
1483 GIT_CEILING_DIRECTORIES="$TRASH_DIRECTORY/.."
1484 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM GIT_CEILING_DIRECTORIES
1486 if test -z "$GIT_TEST_CMP"
1487 then
1488 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1489 then
1490 GIT_TEST_CMP="$DIFF -c"
1491 else
1492 GIT_TEST_CMP="$DIFF -u"
1496 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1497 export GITPERLLIB
1498 test -d "$GIT_BUILD_DIR"/templates/blt || {
1499 BAIL_OUT "You haven't built things yet, have you?"
1502 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1503 then
1504 BAIL_OUT 'You need to build test-tool; Run "make t/helper/test-tool" in the source (toplevel) directory'
1507 # Are we running this test at all?
1508 remove_trash=
1509 this_test=${0##*/}
1510 this_test=${this_test%%-*}
1511 if match_pattern_list "$this_test" "$GIT_SKIP_TESTS"
1512 then
1513 say_color info >&3 "skipping test $this_test altogether"
1514 skip_all="skip all tests in $this_test"
1515 test_done
1518 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK () {
1519 BAIL_OUT "$1 has no effect except when compiled with SANITIZE=leak"
1522 if test -n "$SANITIZE_LEAK"
1523 then
1524 # Normalize with test_bool_env
1525 passes_sanitize_leak=
1527 # We need to see TEST_PASSES_SANITIZE_LEAK in "test-tool
1528 # env-helper" (via test_bool_env)
1529 export TEST_PASSES_SANITIZE_LEAK
1530 if test_bool_env TEST_PASSES_SANITIZE_LEAK false
1531 then
1532 passes_sanitize_leak=t
1535 if test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check" ||
1536 test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check-failing"
1537 then
1538 if test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check-failing" &&
1539 test -n "$passes_sanitize_leak"
1540 then
1541 skip_all="skipping leak-free $this_test under GIT_TEST_PASSING_SANITIZE_LEAK=check-failing"
1542 test_done
1545 sanitize_leak_check=t
1546 if test -n "$invert_exit_code"
1547 then
1548 BAIL_OUT "cannot use --invert-exit-code under GIT_TEST_PASSING_SANITIZE_LEAK=check"
1551 if test -z "$passes_sanitize_leak"
1552 then
1553 say "in GIT_TEST_PASSING_SANITIZE_LEAK=check mode, setting --invert-exit-code for TEST_PASSES_SANITIZE_LEAK != true"
1554 invert_exit_code=t
1556 elif test -z "$passes_sanitize_leak" &&
1557 test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1558 then
1559 skip_all="skipping $this_test under GIT_TEST_PASSING_SANITIZE_LEAK=true"
1560 test_done
1563 rm -rf "$TEST_RESULTS_SAN_DIR"
1564 if ! mkdir -p "$TEST_RESULTS_SAN_DIR"
1565 then
1566 BAIL_OUT "cannot create $TEST_RESULTS_SAN_DIR"
1567 fi &&
1568 TEST_RESULTS_SAN_FILE="$TEST_RESULTS_SAN_DIR/$TEST_RESULTS_SAN_FILE_PFX"
1570 # Don't litter *.leak dirs if there was nothing to report
1571 test_atexit "rmdir \"$TEST_RESULTS_SAN_DIR\" 2>/dev/null || :"
1573 prepend_var LSAN_OPTIONS : dedup_token_length=9999
1574 prepend_var LSAN_OPTIONS : log_exe_name=1
1575 prepend_var LSAN_OPTIONS : log_path=\"$TEST_RESULTS_SAN_FILE\"
1576 export LSAN_OPTIONS
1578 elif test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check" ||
1579 test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check-failing" ||
1580 test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1581 then
1582 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK "GIT_TEST_PASSING_SANITIZE_LEAK=true"
1585 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0 &&
1586 test "${GIT_TEST_EXT_CHAIN_LINT:-1}" != 0
1587 then
1588 "$PERL_PATH" "$TEST_DIRECTORY/chainlint.pl" "$0" ||
1589 BUG "lint error (see 'LINT' annotations above)"
1592 # Last-minute variable setup
1593 USER_HOME="$HOME"
1594 HOME="$TRASH_DIRECTORY"
1595 GNUPGHOME="$HOME/gnupg-home-not-used"
1596 export HOME GNUPGHOME USER_HOME
1598 # "rm -rf" existing trash directory, even if a previous run left it
1599 # with bad permissions.
1600 remove_trash_directory () {
1601 dir="$1"
1602 if ! rm -rf "$dir" 2>/dev/null
1603 then
1604 chmod -R u+rwx "$dir"
1605 rm -rf "$dir"
1607 ! test -d "$dir"
1610 # Test repository
1611 remove_trash_directory "$TRASH_DIRECTORY" || {
1612 BAIL_OUT 'cannot prepare test area'
1615 remove_trash=t
1616 if test -z "$TEST_NO_CREATE_REPO"
1617 then
1618 git init \
1619 ${TEST_CREATE_REPO_NO_TEMPLATE:+--template=} \
1620 "$TRASH_DIRECTORY" >&3 2>&4 ||
1621 error "cannot run git init"
1622 else
1623 mkdir -p "$TRASH_DIRECTORY"
1626 # Use -P to resolve symlinks in our working directory so that the cwd
1627 # in subprocesses like git equals our $PWD (for pathname comparisons).
1628 cd -P "$TRASH_DIRECTORY" || BAIL_OUT "cannot cd -P to \"$TRASH_DIRECTORY\""
1630 start_test_output "$0"
1632 # Convenience
1633 # A regexp to match 5 and 35 hexdigits
1634 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1635 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1637 test_oid_init
1639 ZERO_OID=$(test_oid zero)
1640 OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1641 OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1642 EMPTY_TREE=$(test_oid empty_tree)
1643 EMPTY_BLOB=$(test_oid empty_blob)
1645 # Provide an implementation of the 'yes' utility; the upper bound
1646 # limit is there to help Windows that cannot stop this loop from
1647 # wasting cycles when the downstream stops reading, so do not be
1648 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1649 # limit the output of the yes utility", 2016-02-02)
1650 yes () {
1651 if test $# = 0
1652 then
1654 else
1655 y="$*"
1659 while test $i -lt 99
1661 echo "$y"
1662 i=$(($i+1))
1663 done
1666 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1667 # thus needs to be set up really early, and set an internal variable
1668 # for convenience so the hot test_set_prereq() codepath doesn't need
1669 # to call "test-tool env-helper" (via test_bool_env). Only do that work
1670 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1671 GIT_TEST_FAIL_PREREQS_INTERNAL=
1672 if test -n "$GIT_TEST_FAIL_PREREQS"
1673 then
1674 if test_bool_env GIT_TEST_FAIL_PREREQS false
1675 then
1676 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1677 test_set_prereq FAIL_PREREQS
1679 else
1680 test_lazy_prereq FAIL_PREREQS '
1681 test_bool_env GIT_TEST_FAIL_PREREQS false
1685 # Fix some commands on Windows, and other OS-specific things
1686 uname_s=$(uname -s)
1687 case $uname_s in
1688 *MINGW*)
1689 # Windows has its own (incompatible) sort and find
1690 sort () {
1691 /usr/bin/sort "$@"
1693 find () {
1694 /usr/bin/find "$@"
1696 # git sees Windows-style pwd
1697 pwd () {
1698 builtin pwd -W
1700 # no POSIX permissions
1701 # backslashes in pathspec are converted to '/'
1702 # exec does not inherit the PID
1703 test_set_prereq MINGW
1704 test_set_prereq NATIVE_CRLF
1705 test_set_prereq SED_STRIPS_CR
1706 test_set_prereq GREP_STRIPS_CR
1707 test_set_prereq WINDOWS
1708 GIT_TEST_CMP="GIT_DIR=/dev/null git diff --no-index --ignore-cr-at-eol --"
1710 *CYGWIN*)
1711 test_set_prereq POSIXPERM
1712 test_set_prereq EXECKEEPSPID
1713 test_set_prereq CYGWIN
1714 test_set_prereq SED_STRIPS_CR
1715 test_set_prereq GREP_STRIPS_CR
1716 test_set_prereq WINDOWS
1719 test_set_prereq POSIXPERM
1720 test_set_prereq BSLASHPSPEC
1721 test_set_prereq EXECKEEPSPID
1723 esac
1725 # Detect arches where a few things don't work
1726 uname_m=$(uname -m)
1727 case $uname_m in
1728 parisc* | hppa*)
1729 test_set_prereq HPPA
1731 esac
1733 case "$GIT_DEFAULT_REF_FORMAT" in
1734 files)
1735 test_set_prereq REFFILES;;
1736 reftable)
1737 test_set_prereq REFTABLE;;
1739 echo 2>&1 "error: unknown ref format $GIT_DEFAULT_REF_FORMAT"
1740 exit 1
1742 esac
1744 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1745 test -z "$NO_CURL" && test_set_prereq LIBCURL
1746 test -z "$NO_PERL" && test_set_prereq PERL
1747 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1748 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1749 test -n "$USE_LIBPCRE2" && test_set_prereq PCRE
1750 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1751 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1752 test -n "$SANITIZE_LEAK" && test_set_prereq SANITIZE_LEAK
1753 test -n "$GIT_VALGRIND_ENABLED" && test_set_prereq VALGRIND
1755 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1756 then
1757 GIT_TEST_CHECK_CACHE_TREE=true
1758 export GIT_TEST_CHECK_CACHE_TREE
1761 test_lazy_prereq PIPE '
1762 # test whether the filesystem supports FIFOs
1763 test_have_prereq !MINGW,!CYGWIN &&
1764 rm -f testfifo && mkfifo testfifo
1767 test_lazy_prereq SYMLINKS '
1768 # test whether the filesystem supports symbolic links
1769 ln -s x y && test -h y
1772 test_lazy_prereq SYMLINKS_WINDOWS '
1773 # test whether symbolic links are enabled on Windows
1774 test_have_prereq MINGW &&
1775 cmd //c "mklink y x" &> /dev/null && test -h y
1778 test_lazy_prereq FILEMODE '
1779 test "$(git config --bool core.filemode)" = true
1782 test_lazy_prereq CASE_INSENSITIVE_FS '
1783 echo good >CamelCase &&
1784 echo bad >camelcase &&
1785 test "$(cat CamelCase)" != good
1788 test_lazy_prereq FUNNYNAMES '
1789 test_have_prereq !MINGW &&
1790 touch -- \
1791 "FUNNYNAMES tab embedded" \
1792 "FUNNYNAMES \"quote embedded\"" \
1793 "FUNNYNAMES newline
1794 embedded" 2>/dev/null &&
1795 rm -- \
1796 "FUNNYNAMES tab embedded" \
1797 "FUNNYNAMES \"quote embedded\"" \
1798 "FUNNYNAMES newline
1799 embedded" 2>/dev/null
1802 test_lazy_prereq UTF8_NFD_TO_NFC '
1803 # check whether FS converts nfd unicode to nfc
1804 auml=$(printf "\303\244")
1805 aumlcdiar=$(printf "\141\314\210")
1806 >"$auml" &&
1807 test -f "$aumlcdiar"
1810 test_lazy_prereq AUTOIDENT '
1811 sane_unset GIT_AUTHOR_NAME &&
1812 sane_unset GIT_AUTHOR_EMAIL &&
1813 git var GIT_AUTHOR_IDENT
1816 test_lazy_prereq EXPENSIVE '
1817 test -n "$GIT_TEST_LONG"
1820 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1821 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1824 test_lazy_prereq USR_BIN_TIME '
1825 test -x /usr/bin/time
1828 test_lazy_prereq NOT_ROOT '
1829 uid=$(id -u) &&
1830 test "$uid" != 0
1833 test_lazy_prereq JGIT '
1834 jgit --version
1837 # SANITY is about "can you correctly predict what the filesystem would
1838 # do by only looking at the permission bits of the files and
1839 # directories?" A typical example of !SANITY is running the test
1840 # suite as root, where a test may expect "chmod -r file && cat file"
1841 # to fail because file is supposed to be unreadable after a successful
1842 # chmod. In an environment (i.e. combination of what filesystem is
1843 # being used and who is running the tests) that lacks SANITY, you may
1844 # be able to delete or create a file when the containing directory
1845 # doesn't have write permissions, or access a file even if the
1846 # containing directory doesn't have read or execute permissions.
1848 test_lazy_prereq SANITY '
1849 mkdir SANETESTD.1 SANETESTD.2 &&
1851 chmod +w SANETESTD.1 SANETESTD.2 &&
1852 >SANETESTD.1/x 2>SANETESTD.2/x &&
1853 chmod -w SANETESTD.1 &&
1854 chmod -r SANETESTD.1/x &&
1855 chmod -rx SANETESTD.2 ||
1856 BUG "cannot prepare SANETESTD"
1858 ! test -r SANETESTD.1/x &&
1859 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1860 status=$?
1862 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1863 rm -rf SANETESTD.1 SANETESTD.2 ||
1864 BUG "cannot clean SANETESTD"
1865 return $status
1868 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1869 GIT_UNZIP=${GIT_UNZIP:-unzip}
1870 test_lazy_prereq UNZIP '
1871 "$GIT_UNZIP" -v
1872 test $? -ne 127
1875 run_with_limited_cmdline () {
1876 (ulimit -s 128 && "$@")
1879 test_lazy_prereq CMDLINE_LIMIT '
1880 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1881 run_with_limited_cmdline true
1884 run_with_limited_stack () {
1885 (ulimit -s 128 && "$@")
1888 test_lazy_prereq ULIMIT_STACK_SIZE '
1889 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1890 run_with_limited_stack true
1893 run_with_limited_open_files () {
1894 (ulimit -n 32 && "$@")
1897 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1898 test_have_prereq !MINGW,!CYGWIN &&
1899 run_with_limited_open_files true
1902 build_option () {
1903 git version --build-options |
1904 sed -ne "s/^$1: //p"
1907 test_lazy_prereq SIZE_T_IS_64BIT '
1908 test 8 -eq "$(build_option sizeof-size_t)"
1911 test_lazy_prereq LONG_IS_64BIT '
1912 test 8 -le "$(build_option sizeof-long)"
1915 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1916 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1918 test_lazy_prereq CURL '
1919 curl --version
1922 # SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1923 # which will not work with other hash algorithms and tests that work but don't
1924 # test anything meaningful (e.g. special values which cause short collisions).
1925 test_lazy_prereq SHA1 '
1926 case "$GIT_DEFAULT_HASH" in
1927 sha1) true ;;
1928 "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1929 *) false ;;
1930 esac
1933 test_lazy_prereq DEFAULT_REPO_FORMAT '
1934 test_have_prereq SHA1,REFFILES
1937 # Ensure that no test accidentally triggers a Git command
1938 # that runs the actual maintenance scheduler, affecting a user's
1939 # system permanently.
1940 # Tests that verify the scheduler integration must set this locally
1941 # to avoid errors.
1942 GIT_TEST_MAINT_SCHEDULER="none:exit 1"
1943 export GIT_TEST_MAINT_SCHEDULER
1945 # Does this platform support `git fsmonitor--daemon`
1947 test_lazy_prereq FSMONITOR_DAEMON '
1948 git version --build-options >output &&
1949 grep "feature: fsmonitor--daemon" output